
from src.sql.cruds.biketag_user import BikeTagUserCrud
from src.sql.models.biketag_user import BiketagUserBase, BiketagUserModel
from src.logs import Log
from src.settings import Settings

log = Log("controllers_biketag_user")
config = Settings().get_config()


class BiketagUser(object):
    def __init__(self, id, guild_id, point=0):
        self.id = id
        self.guild_id = guild_id
        self.point = point
        return

    def get(self):
        if self.is_registered():
            biketag_user = BiketagUserBase(id=self.id, guild_id=self.guild_id)
            user = BikeTagUserCrud.get_user(biketag_user)
            self.id = user.id
            self.guild_id = user.guild_id
            self.point = user.point
        else:
            return BiketagUserBase(id=self.id, guild_id=self.guild_id)

    def is_registered(self):
        biketag_user = BiketagUserBase(id=self.id, guild_id=self.guild_id)
        if BikeTagUserCrud.get_user(biketag_user):
            return True
        else:
            log.error(f"This user ({self.id}) doesn't exist.")
            return False

    def register(self):
        biketag_user = BiketagUserBase(id=self.id, guild_id=self.guild_id)
        request = BikeTagUserCrud.create_user(biketag_user)
        if request:
            log.info(f"User {self.id} registered")
            return True
        else:
            log.error(f"An error occured to register user {id}")
            return False

    def add_point(self):
        self.point += 1
        return self.update()

    def update(self):
        biketag_user = BiketagUserModel(
            id=self.id, guild_id=self.guild_id, point=self.point
        )
        request = BikeTagUserCrud.update_user(biketag_user)
        return

    def delete(self):
        guild = guildBase(guild_id=self.guild_id, channel_id=self.channel_id)
        request = guildCrud.delete_guild(guild)
        if request["deleted"] > 0:
            log.info(f"Guild {self.guild_id} was correctly remove")
        else:
            log.error(f"An error occured on guild {self.guild_id} deletion")
        return
