#!/usr/bin/env python3

from src.logs import Log
from src.settings import Settings
from sqlalchemy import create_engine
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import sessionmaker
from sqlalchemy.pool import NullPool

log = Log("database")
config = Settings().get_config()

SQLALCHEMY_DATABASE_URL_RW = "postgresql://{user}:{password}@{host}:{port}/{db}".format(
    user=config["db"]["user"],
    password=config["db"]["password"],
    host=config["db"]["host"],
    port=config["db"]["port"],
    db=config["db"]["dbname"],
    )

engine_rw = create_engine(
    SQLALCHEMY_DATABASE_URL_RW,
    echo=False,
    poolclass=NullPool,
)

SessionLocalRw = sessionmaker(
    autocommit=False, autoflush=False, expire_on_commit=False, bind=engine_rw
)

SQLALCHEMY_DATABASE_URL_RO = "postgresql://{user}:{password}@{host}:{port}/{db}".format(
    user=config["db"]["user"],
    password=config["db"]["password"],
    host=config["db"]["host"],
    port=config["db"]["port"],
    db=config["db"]["dbname"],
    )

engine_ro = create_engine(
    SQLALCHEMY_DATABASE_URL_RO,
    echo=False,
    poolclass=NullPool,
)

SessionLocalRo = sessionmaker(
    autocommit=False, autoflush=False, expire_on_commit=False, bind=engine_ro
)

Base = declarative_base()
